"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class CalledGenotype(ProtocolElement):
    """
    This is intended to hold the genotypes for the family members     In
    principle it is a phased zygosity as in VCF spec and called by the
    analysis provider if further phasing is conducted
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "gelId",
        "genotype",
        "sampleId",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "genotype": reports_4_2_0.Zygosity,
        }

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_5_0_0 import reports as reports_4_2_0

        return {
            "org.gel.models.report.avro.Zygosity": reports_4_2_0.Zygosity,
            "org.gel.models.report.avro.CalledGenotype": reports_4_2_0.CalledGenotype,
        }

    __slots__ = [
        "gelId",
        "genotype",
        "sampleId",
        "copyNumber",
        "depthAlternate",
        "depthReference",
        "phaseSet",
    ]

    def __init__(
        self,
        gelId,
        genotype,
        sampleId,
        copyNumber=None,
        depthAlternate=None,
        depthReference=None,
        phaseSet=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_4_2_0.CalledGenotype model.

        :param gelId:
            Participant id of the family member:
        :type gelId: str
        :param genotype:
            Zygosity
        :type genotype: Zygosity
        :param sampleId:
            LP Number of the family member:
        :type sampleId: str
        :param copyNumber:
            Copy number genotype for imprecise events
        :type copyNumber: None | int
        :param depthAlternate:
            Depth for Alternate Allele
        :type depthAlternate: None | int
        :param depthReference:
            Depth for Reference Allele
        :type depthReference: None | int
        :param phaseSet:
            Phase set of variants when variants are phased
        :type phaseSet: None | int
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "4.2.0"
